//Copyright  2015 Max "Shrinker" Wieden
//Refer to license for license details.
[@vertex330]
layout(std140) uniform matrices
{
	mat4
		modelviewMatrix ,
		projectionMatrix;
};

in vec3
	vPosition,
	vNormal  ;

out vec3 n;

void main()
{
	gl_Position = projectionMatrix*modelviewMatrix*vec4(vPosition, 1);
	n           = vNormal;
}

[@fragment330]
#ifndef WA_NVIDIA
const float
#else
float
#endif
	Pi = 2*asin(1.f);

in vec3 n;

out vec4 fragColor;

const float
	SunAmbient =    .8f,
	SunHeading =  30   ,
	SunPitch   = -60   ;

void main()
{
#ifndef WA_NVIDIA
	const float
#else
	float
#endif
		p = Pi*SunPitch/180,
		t = cos(p)         ;
	float light = SunAmbient-dot(normalize(n), vec3(-sin(Pi*SunHeading/180)*t, sin(p), -cos(Pi*SunHeading/180)*t))*(1-SunAmbient);
	fragColor   = vec4((n+vec3(1))/2, 1);
}
